Subject: Perl 5.6.1 is available
From: Gurusamy Sarathy <[email-masked]>
To: [email-masked], Gurusamy Sarathy <[email-masked]>
Date: Mon, 16 Apr 2001 11:14:41 -0700
Newsgroups: comp.lang.perl.announce,comp.lang.perl.misc

The first maintenance update for Perl 5.6.0 was released on April
8, 2001, and is now available from the Comprehensive Perl Network
Archive (CPAN) sites worldwide.  For example:

    http://www.perl.org/CPAN/src/5.0/perl-5.6.1.tar.gz
    http://www.perl.com/CPAN/src/5.0/perl-5.6.1.tar.gz

A patch against Perl 5.6.0 is also available:

    http://www.perl.org/CPAN/authors/id/GSAR/perl-5.6.1.patch.gz
    http://www.perl.com/CPAN/authors/id/GSAR/perl-5.6.1.patch.gz

You can apply it against the Perl 5.6.0 source tree with:

    gzip -d perl-5.6.1.patch.gz
    cd perl-5.6.0
    sh ../perl-5.6.1.patch
    patch -p1 -N < ../perl-5.6.1.patch

For a brief overview of what is new in the 5.6.0 series and other
important information about reporting problems, see the release
announcement for Perl 5.6.0:

    http://www.perl.org/CPAN/authors/id/GSAR/perl-5.6.0.announce

A summary of the particular fixes, known issues, and late-breaking news
on the 5.6.1 release is included below.  If you are curious about
particular changes, more detailed information can be found in the
"pod/perldelta.pod" and "Changes" files in the Perl 5.6.1 distribution.

If you're a happy user of Perl, spread that joy around!  Advocate
Perl in your organization!  Contribute your code to the CPAN!

--The Perl Porters

----------------------------------------------------------------------------
Summary of Changes in Maintenance Update #1
----------------------------------------------------------------------------

The following excerpt is taken from perl-5.6.1/pod/perldelta.pod:

:Summary of changes between 5.6.0 and 5.6.1
:    This section contains a summary of the changes between the 5.6.0 release
:    and the 5.6.1 release. More details about the changes mentioned here may
:    be found in the Changes files that accompany the Perl source
:    distribution. See the perlhack manpage for pointers to online resources
:    where you can inspect the individual patches described by these changes.
:
:  Security Issues
:
:    suidperl will not run /bin/mail anymore, because some platforms have a
:    /bin/mail that is vulnerable to buffer overflow attacks.
:
:    Note that suidperl is neither built nor installed by default in any
:    recent version of perl. Use of suidperl is highly discouraged. If you
:    think you need it, try alternatives such as sudo first. See
:    http://www.courtesan.com/sudo/.
:
:  Core bug fixes
:
:    This is not an exhaustive list. It is intended to cover only the
:    significant user-visible changes.
:
:    "UNIVERSAL::isa()"
:        A bug in the caching mechanism used by "UNIVERSAL::isa()" that
:        affected base.pm has been fixed. The bug has existed since the 5.005
:        releases, but wasn't tickled by base.pm in those releases.
:
:    Memory leaks
:        Various cases of memory leaks and attempts to access uninitialized
:        memory have been cured. See the section on "Known Problems" below
:        for further issues.
:
:    Numeric conversions
:        Numeric conversions did not recognize changes in the string value
:        properly in certain circumstances.
:
:        In other situations, large unsigned numbers (those above 2**31)
:        could sometimes lose their unsignedness, causing bogus results in
:        arithmetic operations.
:
:        Integer modulus on large unsigned integers sometimes returned
:        incorrect values.
:
:        Perl 5.6.0 generated "not a number" warnings on certain conversions
:        where previous versions didn't.
:
:        These problems have all been rectified.
:
:        Infinity is now recognized as a number.
:
:    qw(a\\b)
:        In Perl 5.6.0, qw(a\\b) produced a string with two backslashes
:        instead of one, in a departure from the behavior in previous
:        versions. The older behavior has been reinstated.
:
:    caller()
:        caller() could cause core dumps in certain situations. Carp was
:        sometimes affected by this problem.
:
:    Bugs in regular expressions
:        Pattern matches on overloaded values are now handled correctly.
:
:        Perl 5.6.0 parsed m/\x{ab}/ incorrectly, leading to spurious
:        warnings. This has been corrected.
:
:        The RE engine found in Perl 5.6.0 accidentally pessimised certain
:        kinds of simple pattern matches. These are now handled better.
:
:        Regular expression debug output (whether through "use re 'debug'" or
:        via "-Dr") now looks better.
:
:        Multi-line matches like ""a\nxb\n" =~ /(?!\A)x/m" were flawed. The
:        bug has been fixed.
:
:        Use of $& could trigger a core dump under some situations. This is
:        now avoided.
:
:        Match variables $1 et al., weren't being unset when a pattern match
:        was backtracking, and the anomaly showed up inside "/...(?{ ...
:        }).../" etc. These variables are now tracked correctly.
:
:        pos() did not return the correct value within s///ge in earlier
:        versions. This is now handled correctly.
:
:    "slurp" mode
:        readline() on files opened in "slurp" mode could return an extra ""
:        at the end in certain situations. This has been corrected.
:
:    Autovivification of symbolic references to special variables
:        Autovivification of symbolic references of special variables
:        described in the perlvar manpage (as in "${$num}") was accidentally
:        disabled. This works again now.
:
:    Lexical warnings
:        Lexical warnings now propagate correctly into "eval "..."".
:
:        "use warnings qw(FATAL all)" did not work as intended. This has been
:        corrected.
:
:        Lexical warnings could leak into other scopes in some situations.
:        This is now fixed.
:
:        warnings::enabled() now reports the state of $^W correctly if the
:        caller isn't using lexical warnings.
:
:    Spurious warnings and errors
:        Perl 5.6.0 could emit spurious warnings about redefinition of
:        dl_error() when statically building extensions into perl. This has
:        been corrected.
:
:        "our" variables could result in bogus "Variable will not stay
:        shared" warnings. This is now fixed.
:
:        "our" variables of the same name declared in two sibling blocks
:        resulted in bogus warnings about "redeclaration" of the variables.
:        The problem has been corrected.
:
:    glob()
:        Compatibility of the builtin glob() with old csh-based glob has been
:        improved with the addition of GLOB_ALPHASORT option. See
:        "File::Glob".
:
:        File::Glob::glob() has been renamed to File::Glob::bsd_glob()
:        because the name clashes with the builtin glob(). The older name is
:        still available for compatibility, but is deprecated.
:
:        Spurious syntax errors generated in certain situations, when glob()
:        caused File::Glob to be loaded for the first time, have been fixed.
:
:    Tainting
:        Some cases of inconsistent taint propagation (such as within hash
:        values) have been fixed.
:
:        The tainting behavior of sprintf() has been rationalized. It does
:        not taint the result of floating point formats anymore, making the
:        behavior consistent with that of string interpolation.
:
:    sort()
:        Arguments to sort() weren't being provided the right wantarray()
:        context. The comparison block is now run in scalar context, and the
:        arguments to be sorted are always provided list context.
:
:        sort() is also fully reentrant, in the sense that the sort function
:        can itself call sort(). This did not work reliably in previous
:        releases.
:
:    #line directives
:        #line directives now work correctly when they appear at the very
:        beginning of "eval "..."".
:
:    Subroutine prototypes
:        The (\&) prototype now works properly.
:
:    map()
:        map() could get pathologically slow when the result list it
:        generates is larger than the source list. The performance has been
:        improved for common scenarios.
:
:    Debugger
:        Debugger exit code now reflects the script exit code.
:
:        Condition ""0"" in breakpoints is now treated correctly.
:
:        The "d" command now checks the line number.
:
:        "$." is no longer corrupted by the debugger.
:
:        All debugger output now correctly goes to the socket if RemotePort
:        is set.
:
:    PERL5OPT
:        PERL5OPT can be set to more than one switch group. Previously, it
:        used to be limited to one group of options only.
:
:    chop()
:        chop(@list) in list context returned the characters chopped in
:        reverse order. This has been reversed to be in the right order.
:
:    Unicode support
:        Unicode support has seen a large number of incremental improvements,
:        but continues to be highly experimental. It is not expected to be
:        fully supported in the 5.6.x maintenance releases.
:
:        substr(), join(), repeat(), reverse(), quotemeta() and string
:        concatenation were all handling Unicode strings incorrectly in Perl
:        5.6.0. This has been corrected.
:
:        Support for "tr///CU" and "tr///UC" etc., have been removed since we
:        realized the interface is broken. For similar functionality, see the
:        pack entry in the perlfunc manpage.
:
:        The Unicode Character Database has been updated to version 3.0.1
:        with additions made available to the public as of August 30, 2000.
:
:        The Unicode character classes \p{Blank} and \p{SpacePerl} have been
:        added. "Blank" is like C isblank(), that is, it contains only
:        "horizontal whitespace" (the space character is, the newline isn't),
:        and the "SpacePerl" is the Unicode equivalent of "\s" (\p{Space}
:        isn't, since that includes the vertical tabulator character, whereas
:        "\s" doesn't.)
:
:        If you are experimenting with Unicode support in perl, the
:        development versions of Perl may have more to offer. In particular,
:        I/O layers are now available in the development track, but not in
:        the maintenance track, primarily to do backward compatibility
:        issues. Unicode support is also evolving rapidly on a daily basis in
:        the development track--the maintenance track only reflects the most
:        conservative of these changes.
:
:    64-bit support
:        Support for 64-bit platforms has been improved, but continues to be
:        experimental. The level of support varies greatly among platforms.
:
:    Compiler
:        The B Compiler and its various backends have had many incremental
:        improvements, but they continue to remain highly experimental. Use
:        in production environments is discouraged.
:
:        The perlcc tool has been rewritten so that the user interface is
:        much more like that of a C compiler.
:
:        The perlbc tools has been removed. Use "perlcc -B" instead.
:
:    Lvalue subroutines
:        There have been various bugfixes to support lvalue subroutines
:        better. However, the feature still remains experimental.
:
:    IO::Socket
:        IO::Socket::INET failed to open the specified port if the service
:        name was not known. It now correctly uses the supplied port number
:        as is.
:
:    File::Find
:        File::Find now chdir()s correctly when chasing symbolic links.
:
:    xsubpp
:        xsubpp now tolerates embedded POD sections.
:
:    "no Module;"
:        "no Module;" does not produce an error even if Module does not have
:        an unimport() method. This parallels the behavior of "use" vis-a-vis
:        "import".
:
:    Tests
:        A large number of tests have been added.
:
:  Core features
:
:    untie() will now call an UNTIE() hook if it exists. See the perltie
:    manpage for details.
:
:    The "-DT" command line switch outputs copious tokenizing information.
:    See the perlrun manpage.
:
:    Arrays are now always interpolated in double-quotish strings.
:    Previously, ""[email-masked]"" used to be a fatal error at compile time, if
:    an array "@bar" was not used or declared. This transitional behavior was
:    intended to help migrate perl4 code, and is deemed to be no longer
:    useful. See the section on "Arrays now always interpolate into
:    double-quoted strings".
:
:    keys(), each(), pop(), push(), shift(), splice() and unshift() can all
:    be overridden now.
:
:    "my __PACKAGE__ $obj" now does the expected thing.
:
:  Configuration issues
:
:    On some systems (IRIX and Solaris among them) the system malloc is
:    demonstrably better. While the defaults haven't been changed in order to
:    retain binary compatibility with earlier releases, you may be better off
:    building perl with "Configure -Uusemymalloc ..." as discussed in the
:    INSTALL file.
:
:    "Configure" has been enhanced in various ways:
:
:    *   Minimizes use of temporary files.
:
:    *   By default, does not link perl with libraries not used by it, such
:        as the various dbm libraries. SunOS 4.x hints preserve behavior on
:        that platform.
:
:    *   Support for pdp11-style memory models has been removed due to
:        obsolescence.
:
:    *   Building outside the source tree is supported on systems that have
:        symbolic links. This is done by running
:
:            sh /path/to/source/Configure -Dmksymlinks ...
:            make all test install
:
:        in a directory other than the perl source directory. See INSTALL.
:
:    *   "Configure -S" can be run non-interactively.
:
:  Documentation
:
:    README.aix, README.solaris and README.macos have been added.
:    README.posix-bc has been renamed to README.bs2000. These are installed
:    as the perlaix manpage, the perlsolaris manpage, the perlmacos manpage,
:    and the perlbs2000 manpage respectively.
:
:    The following pod documents are brand new:
:
:        perlclib    Internal replacements for standard C library functions
:        perldebtut  Perl debugging tutorial
:        perlebcdic  Considerations for running Perl on EBCDIC platforms
:        perlnewmod  Perl modules: preparing a new module for distribution
:        perlrequick Perl regular expressions quick start
:        perlretut   Perl regular expressions tutorial
:        perlutil    utilities packaged with the Perl distribution
:
:    The INSTALL file has been expanded to cover various issues, such as
:    64-bit support.
:
:    A longer list of contributors has been added to the source distribution.
:    See the file "AUTHORS".
:
:    Numerous other changes have been made to the included documentation and
:    FAQs.
:
:  Bundled modules
:
:    The following modules have been added.
:
:    B::Concise
:        Walks Perl syntax tree, printing concise info about ops. See the
:        B::Concise manpage.
:
:    File::Temp
:        Returns name and handle of a temporary file safely. See the
:        File::Temp manpage.
:
:    Pod::LaTeX
:        Converts Pod data to formatted LaTeX. See the Pod::LaTeX manpage.
:
:    Pod::Text::Overstrike
:        Converts POD data to formatted overstrike text. See the
:        Pod::Text::Overstrike manpage.
:
:    The following modules have been upgraded.
:
:    CGI CGI v2.752 is now included.
:
:    CPAN
:        CPAN v1.59_54 is now included.
:
:    Class::Struct
:        Various bugfixes have been added.
:
:    DB_File
:        DB_File v1.75 supports newer Berkeley DB versions, among other
:        improvements.
:
:    Devel::Peek
:        Devel::Peek has been enhanced to support dumping of memory
:        statistics, when perl is built with the included malloc().
:
:    File::Find
:        File::Find now supports pre and post-processing of the files in
:        order to sort() them, etc.
:
:    Getopt::Long
:        Getopt::Long v2.25 is included.
:
:    IO::Poll
:        Various bug fixes have been included.
:
:    IPC::Open3
:        IPC::Open3 allows use of numeric file descriptors.
:
:    Math::BigFloat
:        The fmod() function supports modulus operations. Various bug fixes
:        have also been included.
:
:    Math::Complex
:        Math::Complex handles inf, NaN etc., better.
:
:    Net::Ping
:        ping() could fail on odd number of data bytes, and when the echo
:        service isn't running. This has been corrected.
:
:    Opcode
:        A memory leak has been fixed.
:
:    Pod::Parser
:        Version 1.13 of the Pod::Parser suite is included.
:
:    Pod::Text
:        Pod::Text and related modules have been upgraded to the versions in
:        podlators suite v2.08.
:
:    SDBM_File
:        On dosish platforms, some keys went missing because of lack of
:        support for files with "holes". A workaround for the problem has
:        been added.
:
:    Sys::Syslog
:        Various bug fixes have been included.
:
:    Tie::RefHash
:        Now supports Tie::RefHash::Nestable to automagically tie hashref
:        values.
:
:    Tie::SubstrHash
:        Various bug fixes have been included.
:
:  Platform-specific improvements
:
:    The following new ports are now available.
:
:    NCR MP-RAS
:    NonStop-UX
:    Perl now builds under Amdahl UTS.
:
:    Perl has also been verified to build under Amiga OS.
:
:    Support for EPOC has been much improved. See README.epoc.
:
:    Building perl with -Duseithreads or -Duse5005threads now works under
:    HP-UX 10.20 (previously it only worked under 10.30 or later). You will
:    need a thread library package installed. See README.hpux.
:
:    Long doubles should now work under Linux.
:
:    MacOS Classic is now supported in the mainstream source package. See
:    README.macos.
:
:    Support for MPE/iX has been updated. See README.mpeix.
:
:    Support for OS/2 has been improved. See "os2/Changes" and README.os2.
:
:    Dynamic loading on z/OS (formerly OS/390) has been improved. See
:    README.os390.
:
:    Support for VMS has seen many incremental improvements, including better
:    support for operators like backticks and system(), and better %ENV
:    handling. See "README.vms" and the perlvms manpage.
:
:    Support for Stratus VOS has been improved. See "vos/Changes" and
:    README.vos.
:
:    Support for Windows has been improved.
:
:    *   fork() emulation has been improved in various ways, but still
:        continues to be experimental. See the perlfork manpage for known
:        bugs and caveats.
:
:    *   %SIG has been enabled under USE_ITHREADS, but its use is completely
:        unsupported under all configurations.
:
:    *   Borland C++ v5.5 is now a supported compiler that can build Perl.
:        However, the generated binaries continue to be incompatible with
:        those generated by the other supported compilers (GCC and Visual
:        C++).
:
:    *   Non-blocking waits for child processes (or pseudo-processes) are
:        supported via "waitpid($pid, &POSIX::WNOHANG)".
:
:    *   A memory leak in accept() has been fixed.
:
:    *   wait(), waitpid() and backticks now return the correct exit status
:        under Windows 9x.
:
:    *   Trailing new %ENV entries weren't propagated to child processes.
:        This is now fixed.
:
:    *   Current directory entries in %ENV are now correctly propagated to
:        child processes.
:
:    *   Duping socket handles with open(F, ">&MYSOCK") now works under
:        Windows 9x.
:
:    *   The makefiles now provide a single switch to bulk-enable all the
:        features enabled in ActiveState ActivePerl (a popular binary
:        distribution).
:
:    *   Win32::GetCwd() correctly returns C:\ instead of C: when at the
:        drive root. Other bugs in chdir() and Cwd::cwd() have also been
:        fixed.
:
:    *   fork() correctly returns undef and sets EAGAIN when it runs out of
:        pseudo-process handles.
:
:    *   ExtUtils::MakeMaker now uses $ENV{LIB} to search for libraries.
:
:    *   UNC path handling is better when perl is built to support fork().
:
:    *   A handle leak in socket handling has been fixed.
:
:    *   send() works from within a pseudo-process.

----------------------------------------------------------------------------
Known Issues
----------------------------------------------------------------------------

Issues that arise with Perl releases are fixed as they become known to us.
Individual patches to problems in Perl 5.6.1 (referenced by patch numbers
below) are usually available here:

    http://public.ActiveState.com/gsar/APC/5.6.2/diffs/

Patches that affect the same files should be applied in order, using the
GNU patch utility.  For example:

    cd perl-5.6.1
    gzip -cd 1234.gz | patch -lNp1

Please be aware that, in general, these patches are NOT as thoroughly
tested as the release itself.  Use at your own risk.

The following issues have come to light since Perl 5.6.1 was released:

    + A somewhat obscure case of overeager optimization in the regular
      expression engine has been reported.  The problem may affect you
      if you are matching unanchored patterns with the C</sg> modifiers
      and without also using the C<\G> escape.  Patch 9675 cures this
      problem by reverting the optimization.

    + The File::Glob extension suffers from a widespread buffer overflow
      that affects most software derived from BSD glob().  The problem
      also affects Perl's glob() operator.  If you build or use the (now
      strongly deprecated) suidperl executable, patches 9676, 9678, and
      9679 should be applied.  You may also want to closely study the
      CERT advisory that describes this issue in detail:

          http://www.cert.org/advisories/CA-2001-07.html

      suidperl should be considered unsupported.  Better tools like sudo
      should be used instead.  See http://www.courtesan.com/sudo/.

    + .packlist files generated by Perl 5.6.1 were accidentally
      incompatible with earlier versions.  This problem usually shows
      up as the inability to uninstall extensions using MakeMaker, or
      tools such as PPM.  If you are affected by this, consider applying
      patch 9706.

The following issues were known at the time 5.6.1 was released.  This
list is an excerpt from perl-5.6.1/pod/perldelta.pod:

:  Localizing a tied hash element may leak memory
:
:    As of the 5.6.1 release, there is a known leak when code such as this is
:    executed:
:
:        use Tie::Hash;
:        tie my %tie_hash => 'Tie::StdHash';
:
:        ...
:
:        local($tie_hash{Foo}) = 1; # leaks
:
:  Known test failures
:
:    64-bit builds
:        Subtest #15 of lib/b.t may fail under 64-bit builds on platforms
:        such as HP-UX PA64 and Linux IA64. The issue is still being
:        investigated.
:
:        The lib/io_multihomed test may hang in HP-UX if Perl has been
:        configured to be 64-bit. Because other 64-bit platforms do not hang
:        in this test, HP-UX is suspect. All other tests pass in 64-bit
:        HP-UX. The test attempts to create and connect to "multihomed"
:        sockets (sockets which have multiple IP addresses).
:
:        Note that 64-bit support is still experimental.
:
:    Failure of Thread tests
:        The subtests 19 and 20 of lib/thr5005.t test are known to fail due
:        to fundamental problems in the 5.005 threading implementation. These
:        are not new failures--Perl 5.005_0x has the same bugs, but didn't
:        have these tests. (Note that support for 5.005-style threading
:        remains experimental.)
:
:    NEXTSTEP 3.3 POSIX test failure
:        In NEXTSTEP 3.3p2 the implementation of the strftime(3) in the
:        operating system libraries is buggy: the %j format numbers the days
:        of a month starting from zero, which, while being logical to
:        programmers, will cause the subtests 19 to 27 of the lib/posix test
:        may fail.
:
:    Tru64 (aka Digital UNIX, aka DEC OSF/1) lib/sdbm test failure with gcc
:        If compiled with gcc 2.95 the lib/sdbm test will fail (dump core).
:        The cure is to use the vendor cc, it comes with the operating system
:        and produces good code.
:
:  EBCDIC platforms not fully supported
:
:    In earlier releases of Perl, EBCDIC environments like OS390 (also known
:    as Open Edition MVS) and VM-ESA were supported. Due to changes required
:    by the UTF-8 (Unicode) support, the EBCDIC platforms are not supported
:    in Perl 5.6.0.
:
:    The 5.6.1 release improves support for EBCDIC platforms, but they are
:    not fully supported yet.
:
:  UNICOS/mk CC failures during Configure run
:
:    In UNICOS/mk the following errors may appear during the Configure run:
:
:            Guessing which symbols your C compiler and preprocessor define...
:            CC-20 cc: ERROR File = try.c, Line = 3
:            ...
:              bad switch yylook 79bad switch yylook 79bad switch yylook [...]
:            ...
:            4 errors detected in the compilation of "try.c".
:
:    The culprit is the broken awk of UNICOS/mk. The effect is fortunately
:    rather mild: Perl itself is not adversely affected by the error, only
:    the h2ph utility coming with Perl, and that is rather rarely needed
:    these days.
:
:  Arrow operator and arrays
:
:    When the left argument to the arrow operator "->" is an array, or the
:    "scalar" operator operating on an array, the result of the operation
:    must be considered erroneous. For example:
:
:        @x->[2]
:        scalar(@x)->[2]
:
:    These expressions will get run-time errors in some future release of
:    Perl.
:
:  Experimental features
:
:    As discussed above, many features are still experimental. Interfaces and
:    implementation of these features are subject to change, and in extreme
:    cases, even subject to removal in some future release of Perl. These
:    features include the following:
:
:    Threads
:    Unicode
:    64-bit support
:    Lvalue subroutines
:    Weak references
:    The pseudo-hash data type
:    The Compiler suite
:    Internal implementation of file globbing
:    The DB module
:    The regular expression code constructs:
:        "(?{ code })" and "(??{ code })"

----------------------------------------------------------------------------
Incompatibilities
----------------------------------------------------------------------------

For a list of incompatibilities between 5.6.0 and earlier releases,
please see:

    http://www.perl.org/CPAN/authors/id/GSAR/perl-5.6.0.announce

Other than bug fixes and incompatible changes to experimental features,
most of which have been mentioned above, no known incompatibilities have
been introduced in 5.6.1.

Owing to the large number of changes between 5.6.0 and 5.6.1, it should
be considered essential to test this new release with your production
software in a non-critical environment BEFORE deploying it.  Please
ensure that you can easily fall back to an older, working installation
of Perl if you encounter problems with the transition to Perl 5.6.1.

----------------------------------------------------------------------------
Tested Platforms
----------------------------------------------------------------------------

A large number of platforms are known to build and pass the test suite
with this release.  If you encounter problems, you can search the Perl bug
database for detailed reports about your platform here:

    http://bugs.perl.org/